Index: soft/giet_vm/giet_boot/boot.c
===================================================================
--- soft/giet_vm/giet_boot/boot.c	(revision 490)
+++ soft/giet_vm/giet_boot/boot.c	(revision 493)
@@ -1,21 +1,24 @@
-/////////////////////////////////////////////////////////////////////////////////////////
+///////////////////////////////////////////////////////////////////////////////////////
 // File     : boot.c
 // Date     : 01/11/2013
 // Author   : alain greiner
 // Copyright (c) UPMC-LIP6
-//////////////////////////////////////////////////////////////////////////////////////////
-// The boot.c file is part of the GIET-VM nano-kernel.
+///////////////////////////////////////////////////////////////////////////////////////
+// The boot.c file contains the bootloader for the GIET-VM static OS.  
 //
-// This nano-kernel has been written for the MIPS32 processor.
+// This code has been written for the MIPS32 processor.
 // The virtual adresses are on 32 bits and use the (unsigned int) type. The 
 // physicals addresses can have up to 40 bits, and use the  (unsigned long long) type.
 // It natively supports clusterised shared memory multi-processors architectures, 
-// where each processor is identified by a composite index (cluster_xy, local_id),
+// where each processor is identified by a composite index [x,y,p],
 // and where there is one physical memory bank per cluster.
 //
-// This code, executed in the boot phase by proc[0,0,0], performs the following tasks:
-// - load into memory various binary files, from a FAT32 file system,
-// - build the various page tables (one page table per vspace) 
-// - initialize the shedulers (one scheduler per processor)
+// The boot.elf file is stored on disk and is loaded into memory by proc[0,0,0],
+// executing the generic preloader (stored in ROM). The boot-loader code itself
+// is executed in parallel by all proc[x,y,0], and performs the following tasks:
+// - load into memory various binary files, from a FAT32 file system.
+// - build the various page tables (one page table per vspace). 
+// - initialize the shedulers (one scheduler per processor).
+// - initialize the external peripherals.
 //
 // 1) The binary files to be loaded are:
@@ -23,8 +26,8 @@
 //      mapping directives. It must be stored in the the seg_boot_mapping segment 
 //      (at address SEG_BOOT_MAPPING_BASE defined in hard_config.h file).
-//    - the "sys.elf" file contains the kernel binary code and data.
+//    - the "kernel.elf" file contains the kernel binary code and data.
 //    - the various "application.elf" files.
 //
-// 2) The map.bin file contains the binary representation of the map.xml file defining: 
+// 2) The "map.bin" file contains the C binary structure defining: 
 //    - the hardware architecture: number of clusters, number or processors, 
 //      size of the memory segments, and peripherals in each cluster.
@@ -41,5 +44,6 @@
 //      of the software objects (vsegs) on the physical memory banks (psegs).
 //
-//    The max number of vspaces (GIET_NB_VSPACE_MAX) is a configuration parameter.
+//    The max number of vspaces (GIET_NB_VSPACE_MAX) is a configuration parameter,
+//    and - for each application - the tasks are statically allocateded on procesors.
 //    The page table are statically build in the boot phase, and they do not 
 //    change during execution. 
@@ -52,13 +56,13 @@
 //    A PT2 is indexed the ix2 field (9 bits) of the VPN. Each entry is a double word. 
 //    The first word contains the flags, the second word contains the PPN.
-//
-//    When this is required in the mapping, the page tables can be replicated 
-//    in all clusters.
+//    The page tables are distributed/replicated in all clusters.
 ///////////////////////////////////////////////////////////////////////////////////////
 // Implementation Notes:
 //
 // 1) The cluster_id variable is a linear index in the mapping_info array of clusters. 
-//    We use the cluster_xy variable for the tological index = x << Y_WIDTH + y
+//    The cluster_xy variable is the tological index = x << Y_WIDTH + y
 // 
+// 2) We set the _tty0_boot_mode variable to force the _printf() function to use
+//    the tty0_spin_lock for exclusive access to TTY0.
 ///////////////////////////////////////////////////////////////////////////////////////
 
@@ -67,5 +71,4 @@
 #include <mapping_info.h>
 #include <kernel_malloc.h>
-#include <barrier.h>
 #include <memspace.h>
 #include <tty_driver.h>
@@ -86,5 +89,6 @@
 #include <utils.h>
 #include <tty0.h>
-#include <locks.h>
+#include <kernel_locks.h>
+#include <kernel_barriers.h>
 #include <elf-types.h>
 #include <fat32.h>
@@ -131,80 +135,56 @@
 
 // FAT internal representation for boot code  
-__attribute__((section (".bootdata"))) 
-fat32_fs_t             fat   __attribute__((aligned(512)));
+__attribute__((section(".kdata")))
+fat32_fs_t          fat   __attribute__((aligned(512)));
 
 // Temporaty buffer used to load one complete .elf file  
-__attribute__((section (".bootdata"))) 
-char                   boot_elf_buffer[GIET_ELF_BUFFER_SIZE] __attribute__((aligned(512)));
+__attribute__((section(".kdata")))
+char                boot_elf_buffer[GIET_ELF_BUFFER_SIZE] __attribute__((aligned(512)));
 
 // Physical memory allocators array (one per cluster)
-__attribute__((section (".bootdata"))) 
-pmem_alloc_t           boot_pmem_alloc[X_SIZE][Y_SIZE];
+__attribute__((section(".kdata")))
+pmem_alloc_t        boot_pmem_alloc[X_SIZE][Y_SIZE];
 
 // Distributed kernel heap (one per cluster)
-__attribute__((section (".bootdata"))) 
-kernel_heap_t          kernel_heap[X_SIZE][Y_SIZE];
+// __attribute__((section(".kdata")))
+// kernel_heap_t       kernel_heap[X_SIZE][Y_SIZE];
 
 // Schedulers virtual base addresses array (one per processor)
-__attribute__((section (".bootdata"))) 
-static_scheduler_t*    _schedulers[X_SIZE][Y_SIZE][NB_PROCS_MAX];
+__attribute__((section(".kdata")))
+static_scheduler_t* _schedulers[X_SIZE][Y_SIZE][NB_PROCS_MAX];
 
 // Page tables virtual base addresses array (one per vspace)
-__attribute__((section (".bootdata"))) 
-unsigned int           _ptabs_vaddr[GIET_NB_VSPACE_MAX][X_SIZE][Y_SIZE];
+__attribute__((section(".kdata")))
+unsigned int        _ptabs_vaddr[GIET_NB_VSPACE_MAX][X_SIZE][Y_SIZE];
 
 // Page tables physical base addresses (one per vspace and per cluster)
-__attribute__((section (".bootdata"))) 
-paddr_t                _ptabs_paddr[GIET_NB_VSPACE_MAX][X_SIZE][Y_SIZE];
+__attribute__((section(".kdata")))
+paddr_t             _ptabs_paddr[GIET_NB_VSPACE_MAX][X_SIZE][Y_SIZE];
 
 // Page tables pt2 allocators (one per vspace and per cluster)
-__attribute__((section (".bootdata"))) 
-unsigned int           _ptabs_next_pt2[GIET_NB_VSPACE_MAX][X_SIZE][Y_SIZE];
+__attribute__((section(".kdata")))
+unsigned int        _ptabs_next_pt2[GIET_NB_VSPACE_MAX][X_SIZE][Y_SIZE];
 
 // Page tables max_pt2  (same value for all page tables)
-__attribute__((section (".bootdata"))) 
-unsigned int           _ptabs_max_pt2;
-
-__attribute__((section (".bootdata"))) 
-//volatile struct _boot_init_ok {
-//    unsigned int value;
-//}__attribute__((aligned(64)));
-//struct _boot_init_ok boot_init_ok = {0};
-volatile unsigned int boot_init_ok = 0;
-
-__attribute__((section (".bootdata"))) 
-volatile _giet_lock_t lock_tty;
-
-__attribute__((section (".bootdata"))) 
-volatile _giet_barrier_t barrier_boot;
-
-__attribute__((section (".bootdata"))) 
-volatile _giet_lock_t lock_next_pt2[GIET_NB_VSPACE_MAX][X_SIZE][Y_SIZE];
-
-// Global variables for TTY
-__attribute__((section (".bootdata"))) 
-sbt_lock_t             _tty_tx_lock[NB_TTY_CHANNELS]   __attribute__((aligned(64)));
-
-__attribute__((section (".bootdata"))) 
-unsigned int           _tty_rx_full[NB_TTY_CHANNELS];
-#if BOOT_DEBUG_MAPPING
-unsigned int  word;
-unsigned int  line;
-unsigned int* pointer = (unsigned int*)SEG_BOOT_MAPPING_BASE;
-_puts("\n[BOOT] First block of mapping");
-for ( line = 0 ; line < 8 ; line++ )
-{
-    for ( word = 0 ; word < 8 ; word++ )
-    {
-        _puts(" | ");
-        _putx( *(pointer + word) );
-    }
-    _puts(" |\n");
-    pointer = pointer + 8;
-}
-#endif
-
-__attribute__((section (".bootdata"))) 
-unsigned int           _tty_rx_buf[NB_TTY_CHANNELS];
+__attribute__((section(".kdata")))
+unsigned int        _ptabs_max_pt2;
+
+// WTI channel allocator (one per cluster)
+__attribute__((section(".kdata")))
+unsigned int        _wti_channel_alloc[X_SIZE][Y_SIZE];
+
+// boot code uses a spin lock to protect TTY0
+__attribute__((section(".kdata")))
+unsigned int        _tty0_boot_mode = 1;
+
+__attribute__((section(".kdata")))
+spin_lock_t         _ptabs_spin_lock[GIET_NB_VSPACE_MAX][X_SIZE][Y_SIZE];
+
+// barrier used by boot code for parallel execution
+__attribute__((section(".kdata")))
+simple_barrier_t    _barrier_all_clusters;
+
+// this variable is defined in the tty0.c file
+extern spin_lock_t  _tty0_spin_lock;
 
 //////////////////////////////////////////////////////////////////////////////
@@ -212,4 +192,6 @@
 // by the vspace_id argument, and the (x,y) coordinates.
 // It updates only the first level PT1.
+// As each vseg is mapped by a different processor, the PT1 entry cannot
+// be concurrently accessed, and we don't need to take any lock.
 //////////////////////////////////////////////////////////////////////////////
 void boot_add_pte1( unsigned int vspace_id,
@@ -220,50 +202,14 @@
                     unsigned int ppn )       // 28 bits right-justified
 {
-
-#if (BOOT_DEBUG_PT > 1)
-_get_lock(&lock_tty);
-_puts(" - PTE1 in PTAB[");
-_putd( vspace_id );
-_puts(",");
-_putd( x );
-_puts(",");
-_putd( y );
-_puts("] : vpn = ");
-_putx( vpn );
-_puts(" / ppn = ");
-_putx( ppn );
-_puts(" / flags = ");
-_putx( flags );
-_puts("\n");
-_release_lock(&lock_tty);
-#endif
-
-    unsigned int procid     = _get_procid();
-    unsigned int x_cluster  = (procid >> (Y_WIDTH + P_WIDTH)) & ((1<<X_WIDTH)-1);
-    unsigned int y_cluster  = (procid >> P_WIDTH) & ((1<<Y_WIDTH)-1);
-
     // compute index in PT1
     unsigned int    ix1 = vpn >> 9;         // 11 bits for ix1
 
     // get page table physical base address 
-    paddr_t         pt1_pbase = _ptabs_paddr[vspace_id][x][y];
-
-    // check pt1_base
+    paddr_t  pt1_pbase = _ptabs_paddr[vspace_id][x][y];
+
     if ( pt1_pbase == 0 )
     {
-        _get_lock(&lock_tty);
-        _puts("\n[BOOT ERROR] in boot_add_pte1() : illegal pbase address for PTAB[");
-        _putd( vspace_id );
-        _puts(",");
-        _putd( x );
-        _puts(",");
-        _putd( y );
-        _puts("]");
-        _puts(" in cluster[");
-        _putd(x_cluster);
-        _puts(",");
-        _putd(y_cluster);
-        _puts("]\n");
-        _release_lock(&lock_tty);
+        _printf("\n[BOOT ERROR] in boot_add_pte1() : no PTAB in cluster[%d,%d]"
+                    " containing processors\n", x , y );
         _exit();
     }
@@ -277,18 +223,5 @@
     _physical_write( pt1_pbase + 4*ix1, pte1 );
 
-#if (BOOT_DEBUG_PT > 1 )
-_get_lock(&lock_tty);
-_puts(" - Write pte1 ");
-_putx( pte1 );
-_puts(" in paddr ");
-_putl( pt1_pbase + 4*ix1 );
-_puts(" in cluster[");
-_putd(x_cluster);
-_puts(",");
-_putd(y_cluster);
-_puts("]\n");
-_puts("\n");
-_release_lock(&lock_tty);
-#endif
+    asm volatile ("sync");
 
 }   // end boot_add_pte1()
@@ -300,4 +233,6 @@
 // As the set of PT2s is implemented as a fixed size array (no dynamic 
 // allocation), this function checks a possible overflow of the PT2 array.
+// As a given entry in PT1 can be shared by several vsegs, mapped by 
+// different processors, we need to take the lock protecting PTAB[v][x]y].
 //////////////////////////////////////////////////////////////////////////////
 void boot_add_pte2( unsigned int vspace_id,
@@ -308,23 +243,4 @@
                     unsigned int ppn )       // 28 bits right-justified
 {
-
-#if (BOOT_DEBUG_PT > 1)
-_get_lock(&lock_tty);
-_puts(" - PTE2 in PTAB[");
-_putd( vspace_id );
-_puts(",");
-_putd( x );
-_puts(",");
-_putd( y );
-_puts("] : vpn = ");
-_putx( vpn );
-_puts(" / ppn = ");
-_putx( ppn );
-_puts(" / flags = ");
-_putx( flags );
-_puts("\n");
-_release_lock(&lock_tty);
-#endif
-
     unsigned int ix1;
     unsigned int ix2;
@@ -337,39 +253,32 @@
     ix2 = vpn & 0x1FF;          //  9 bits for ix2
 
-    // get page table physical base address and size
+    // get page table physical base address 
     paddr_t      pt1_pbase = _ptabs_paddr[vspace_id][x][y];
 
-    // check pt1_base
     if ( pt1_pbase == 0 )
     {
-        _get_lock(&lock_tty);
-        _puts("\n[BOOT ERROR] in boot_add_pte2() : PTAB[");
-        _putd( vspace_id );
-        _puts(",");
-        _putd( x );
-        _puts(",");
-        _putd( y );
-        _puts("] undefined\n");
-        _release_lock(&lock_tty);
+        _printf("\n[BOOT ERROR] in boot_add_pte2() : no PTAB for vspace %d "
+                "in cluster[%d,%d]\n", vspace_id , x , y );
         _exit();
     }
 
+    // get lock protecting PTAB[vspace_id][x][y]
+    _spin_lock_acquire( &_ptabs_spin_lock[vspace_id][x][y] );
+
     // get ptd in PT1
-    _get_lock(&lock_next_pt2[vspace_id][x][y]);
-    ptd = _physical_read(pt1_pbase + 4 * ix1);
+    ptd = _physical_read( pt1_pbase + 4 * ix1 );
 
     if ((ptd & PTE_V) == 0)    // undefined PTD: compute PT2 base address, 
                                // and set a new PTD in PT1 
     {
+        // get a new pt2_id
         pt2_id = _ptabs_next_pt2[vspace_id][x][y];
+        _ptabs_next_pt2[vspace_id][x][y] = pt2_id + 1;
+
+        // check overflow
         if (pt2_id == _ptabs_max_pt2) 
         {
-            _puts("\n[BOOT ERROR] in boot_add_pte2() : PTAB[");
-            _putd( vspace_id );
-            _puts(",");
-            _putd( x );
-            _puts(",");
-            _putd( y );
-            _puts("] contains not enough PT2s\n");
+            _printf("\n[BOOT ERROR] in boot_add_pte2() : PTAB[%d,%d,%d]"
+                    " contains not enough PT2s\n", vspace_id, x, y );
             _exit();
         }
@@ -377,6 +286,7 @@
         pt2_pbase = pt1_pbase + PT1_SIZE + PT2_SIZE * pt2_id;
         ptd = PTE_V | PTE_T | (unsigned int) (pt2_pbase >> 12);
+
+        // set PTD into PT1
         _physical_write( pt1_pbase + 4*ix1, ptd);
-        _ptabs_next_pt2[vspace_id][x][y] = pt2_id + 1;
     }
     else                       // valid PTD: compute PT2 base address
@@ -385,9 +295,13 @@
     }
 
-    _release_lock(&lock_next_pt2[vspace_id][x][y]);
     // set PTE in PT2 : flags & PPN in two 32 bits words
     pte2_paddr  = pt2_pbase + 8 * ix2;
-    _physical_write(pte2_paddr     , (PTE_V |flags) );
-    _physical_write(pte2_paddr + 4 , ppn);
+    _physical_write(pte2_paddr     , (PTE_V | flags) );
+    _physical_write(pte2_paddr + 4 , ppn );
+
+    // release lock protecting PTAB[vspace_id][x][y]
+    _spin_lock_release( &_ptabs_spin_lock[vspace_id][x][y] );
+
+    asm volatile ("sync");
 
 }   // end boot_add_pte2()
@@ -397,5 +311,5 @@
 // defined by alignPow2 == L2(alignement).
 ////////////////////////////////////////////////////////////////////////////////////
-paddr_t paddr_align_to(paddr_t paddr, unsigned int alignPow2) 
+paddr_t paddr_align_to( paddr_t paddr, unsigned int alignPow2 ) 
 {
     paddr_t mask = (1 << alignPow2) - 1;
@@ -403,5 +317,5 @@
 }
 
-unsigned int vaddr_align_to(unsigned int vaddr, unsigned int alignPow2) 
+unsigned int vaddr_align_to( unsigned int vaddr, unsigned int alignPow2 ) 
 {
     unsigned int mask = (1 << alignPow2) - 1;
@@ -412,5 +326,5 @@
 // This function map a vseg identified by the vseg pointer.
 //
-// A given vseg can be mapped in Big Physical Pages (BPP: 2 Mbytes) or in a
+// A given vseg can be mapped in a Big Physical Pages (BPP: 2 Mbytes) or in a
 // Small Physical Pages (SPP: 4 Kbytes), depending on the "big" attribute of vseg,
 // with the following rules:
@@ -424,15 +338,15 @@
 //    account the alignment constraints and register it in vobj->vbase field.
 //
-// 2) Second step: it allocates the required number of physical pages, 
+// 2) Second step: it allocates the required number of contiguous physical pages, 
 //    computes the physical base address (if the vseg is not identity mapping),
 //    and register it in the vseg pbase field.
-//    Only the 4 vsegs used by the boot code and the peripheral vsegs
-//    can be identity mapping: The first big physical page in cluster[0,0] 
-//    is reserved for the 4 boot vsegs.
+//    Only the vsegs used by the boot code and the peripheral vsegs
+//    can be identity mapping. The first big physical page in cluster[0,0] 
+//    is reserved for the boot vsegs.
 //
-// 3) Third step (only for vseg that have the VOBJ_TYPE_PTAB): all page tables
-//    associated to the various vspaces must be packed in the same vseg.
-//    We divide the vseg in M sub-segments, and compute the vbase and pbase
-//    addresses for each page table, and register it in the _ptabs_paddr
+// 3) Third step (only for vseg that have the VOBJ_TYPE_PTAB): the M page tables
+//    associated to the M vspaces must be packed in the same vseg.
+//    We divide this vseg in M sub-segments, and compute the vbase and pbase
+//    addresses for M page tables, and register these addresses in the _ptabs_paddr
 //    and _ptabs_vaddr arrays.
 //  
@@ -496,7 +410,7 @@
     //////////// - if vseg is ram      :  ppn <= physical memory allocator
 
-    unsigned int ppn;          // first physical page index ( 28 bits = |x|y|bppi|sppi| ) 
-    unsigned int vpn;          // first virtual page index  ( 20 bits = |ix1|ix2| )
-    unsigned int vpn_max;      // last  virtual page index  ( 20 bits = |ix1|ix2| )
+    unsigned int ppn;          // first physical page index (28 bits = |x|y|bppi|sppi|) 
+    unsigned int vpn;          // first virtual page index  (20 bits = |ix1|ix2|)
+    unsigned int vpn_max;      // last  virtual page index  (20 bits = |ix1|ix2|)
 
     vpn     = vseg->vbase >> 12;
@@ -539,23 +453,5 @@
                     paddr_t      paddr = _ptabs_paddr[vsid][x_dest][y_dest] + (ix1<<2);
                     unsigned int pte1  = _physical_read( paddr );
-#if (BOOT_DEBUG_PT > 1)
-_get_lock(&lock_tty);
-_puts("[BOOT DEBUG] ");
-_puts( vseg->name );
-_puts(" in cluster[");
-_putd( x_dest );
-_puts(",");
-_putd( y_dest );
-_puts("] : vbase = ");
-_putx( vseg->vbase );
-_puts(" / paddr = ");
-_putl( paddr );
-_puts(" / pte1 = ");
-_putx( pte1 );
-_puts(" by processor ");
-_putd(_get_procid());
-_puts("\n");
-_release_lock(&lock_tty);
-#endif
+
                     if ( (pte1 & PTE_V) == 0 )     // BPP not allocated yet
                     {
@@ -572,15 +468,11 @@
                         if (pte1 & PTE_W) pte1_mode |= W_MODE_MASK;
                         if (pte1 & PTE_U) pte1_mode |= U_MODE_MASK;
-                        if (vseg->mode != pte1_mode) {
-                            _puts("\n[BOOT ERROR] in boot_vseg_map() : vseg ");
-                            _puts( vseg->name );
-                            _puts(" has different flags (");
-                            _putx( vseg->mode );
-                            _puts(") than other vsegs sharing the same big page (");
-                            _putx( pte1_mode );
-                            _puts(")");
+                        if (vseg->mode != pte1_mode) 
+                        {
+                            _printf("\n[BOOT ERROR] in boot_vseg_map() : "
+                                    "vseg %s has different flags than another vseg "
+                                    "in the same BPP\n", vseg->name );
                             _exit();
                         }
-
                         ppn = ((pte1 << 9) & 0x0FFFFE00);
                     }
@@ -597,4 +489,5 @@
     // update vseg.pbase field and update vsegs chaining
     vseg->pbase     = ((paddr_t)ppn) << 12;
+    vseg->mapped    = 1;
     vseg->next_vseg = pseg->next_vseg;
     pseg->next_vseg = (unsigned int)vseg;
@@ -637,23 +530,15 @@
     }
 
+    asm volatile ("sync");
+
 #if BOOT_DEBUG_PT
-_get_lock(&lock_tty);
-_puts("[BOOT DEBUG] ");
-_puts( vseg->name );
-_puts(" in cluster[");
-_putd( x_dest );
-_puts(",");
-_putd( y_dest );
-_puts("] : vbase = ");
-_putx( vseg->vbase );
-_puts(" / length = ");
-_putx( vseg->length );
-if ( big ) _puts(" / BIG   / npages = ");
-else       _puts(" / SMALL / npages = ");
-_putd( npages );
-_puts(" / pbase = ");
-_putl( vseg->pbase );
-_puts("\n");
-_release_lock(&lock_tty);
+if ( big )
+_printf("\n[BOOT] vseg %s : cluster[%d,%d] / "
+       "vbase = %x / length = %x / BIG    / npages = %d / pbase = %l\n",
+       vseg->name, x_dest, y_dest, vseg->vbase, vseg->length, npages, vseg-> pbase );
+else
+_printf("\n[BOOT] vseg %s : cluster[%d,%d] / "
+        "vbase = %x / length = %x / SMALL / npages = %d / pbase = %l\n",
+       vseg->name, x_dest, y_dest, vseg->vbase, vseg->length, npages, vseg-> pbase );
 #endif
 
@@ -661,10 +546,10 @@
 
 /////////////////////////////////////////////////////////////////////////////////////
-// For the vseg defined by the vseg pointer, this function register all PTEs
+// For the vseg defined by the vseg pointer, this function register PTEs
 // in one or several page tables.
 // It is a global vseg (kernel vseg) if (vspace_id == 0xFFFFFFFF).
 // The number of involved PTABs depends on the "local" and "global" attributes:
 //  - PTEs are replicated in all vspaces for a global vseg.
-//  - PTEs are replicated in all clusters for a non local vseg.
+//  - PTEs are replicated in all clusters containing procs for a non local vseg.
 /////////////////////////////////////////////////////////////////////////////////////
 void boot_vseg_pte( mapping_vseg_t*  vseg,
@@ -690,7 +575,7 @@
 
     // compute vseg flags
-    // The three flags (Local, Remote and Dirty) are set to 1 to reduce
-    // latency of TLB miss (L/R) and write (D): Avoid hardware update
-    // mechanism for these flags because GIET_VM does use these flags.
+    // The three flags (Local, Remote and Dirty) are set to 1 
+    // to avoid hardware update for these flags, because GIET_VM 
+    // does use these flags.
     unsigned int flags = 0;
     if (vseg->mode & C_MODE_MASK) flags |= PTE_C;
@@ -711,19 +596,17 @@
     else            npages  = (vpn_max>>9) - (vpn>>9) + 1; 
 
-    // compute destination cluster coordinates
-    unsigned int        x_dest;
-    unsigned int        y_dest;
-    mapping_header_t*   header  = (mapping_header_t *)SEG_BOOT_MAPPING_BASE;
-    mapping_cluster_t*  cluster = _get_cluster_base(header);
-    mapping_pseg_t*     pseg    = _get_pseg_base(header);
-    pseg     = pseg + vseg->psegid;
-    cluster  = cluster + pseg->clusterid;
-    x_dest   = cluster->x;
-    y_dest   = cluster->y;
-
-    unsigned int p;     // iterator for physical page index
-    unsigned int x;     // iterator for cluster x coordinate  
-    unsigned int y;     // iterator for cluster y coordinate  
-    unsigned int v;     // iterator for vspace index 
+    // compute destination cluster coordinates, for local vsegs
+    mapping_header_t*   header       = (mapping_header_t *)SEG_BOOT_MAPPING_BASE;
+    mapping_cluster_t*  cluster      = _get_cluster_base(header);
+    mapping_pseg_t*     pseg         = _get_pseg_base(header);
+    mapping_pseg_t*     pseg_dest    = &pseg[vseg->psegid];
+    mapping_cluster_t*  cluster_dest = &cluster[pseg_dest->clusterid];
+    unsigned int        x_dest       = cluster_dest->x;
+    unsigned int        y_dest       = cluster_dest->y;
+
+    unsigned int p;           // iterator for physical page index
+    unsigned int x;           // iterator for cluster x coordinate  
+    unsigned int y;           // iterator for cluster y coordinate  
+    unsigned int v;           // iterator for vspace index 
 
     // loop on PTEs
@@ -757,21 +640,24 @@
                 for ( y = 0 ; y < Y_SIZE ; y++ )
                 {
-                    if ( big )   // big pages => PTE1s
+                    if ( cluster[(x * Y_SIZE) + y].procs )
                     {
-                        boot_add_pte1( vsid,
-                                       x,
-                                       y,
-                                       vpn + (p<<9),
-                                       flags, 
-                                       ppn + (p<<9) );
-                    }
-                    else         // small pages => PTE2s
-                    {
-                        boot_add_pte2( vsid,
-                                       x,
-                                       y,
-                                       vpn + p,
-                                       flags, 
-                                       ppn + p );
+                        if ( big )   // big pages => PTE1s
+                        {
+                            boot_add_pte1( vsid,
+                                           x,
+                                           y,
+                                           vpn + (p<<9),
+                                           flags, 
+                                           ppn + (p<<9) );
+                        }
+                        else         // small pages => PTE2s
+                        {
+                            boot_add_pte2( vsid,
+                                           x,
+                                           y,
+                                           vpn + p,
+                                           flags, 
+                                           ppn + p );
+                        }
                     }
                 }
@@ -808,23 +694,26 @@
                 for ( y = 0 ; y < Y_SIZE ; y++ )
                 {
-                    for ( v = 0 ; v < header->vspaces ; v++ )
+                    if ( cluster[(x * Y_SIZE) + y].procs )
                     {
-                        if ( big )  // big pages => PTE1s
+                        for ( v = 0 ; v < header->vspaces ; v++ )
                         {
-                            boot_add_pte1( v,
-                                           x,
-                                           y,
-                                           vpn + (p<<9),
-                                           flags, 
-                                           ppn + (p<<9) );
-                        }
-                        else        // small pages -> PTE2s
-                        {
-                            boot_add_pte2( v,
-                                           x,
-                                           y,
-                                           vpn + p,
-                                           flags, 
-                                           ppn + p );
+                            if ( big )  // big pages => PTE1s
+                            {
+                                boot_add_pte1( v,
+                                               x,
+                                               y,
+                                               vpn + (p<<9),
+                                               flags, 
+                                               ppn + (p<<9) );
+                            }
+                            else        // small pages -> PTE2s
+                            {
+                                boot_add_pte2( v,
+                                               x,
+                                               y,
+                                               vpn + p,
+                                               flags, 
+                                               ppn + p );
+                            }
                         }
                     }
@@ -833,21 +722,46 @@
         }
     }  // end for pages
+
+    asm volatile ("sync");
+
 }  // end boot_vseg_pte()
 
+
 ///////////////////////////////////////////////////////////////////////////////
-// This function initialises the page tables for all vspaces defined 
-// in the mapping_info data structure.
-// For each vspace, there is one page table per cluster.
+// Processor P[x][y][0] computes physical base address for all globals vsegs,
+// using the local Page Table, to check page tables initialisation.
+///////////////////////////////////////////////////////////////////////////////
+void boot_ptab_check( unsigned int x,
+                      unsigned int y )
+{
+    mapping_header_t*   header = (mapping_header_t *)SEG_BOOT_MAPPING_BASE;
+    mapping_vseg_t*     vseg   = _get_vseg_base(header);
+    page_table_t*       ptab   = (page_table_t*)_ptabs_vaddr[0][x][y];
+
+    unsigned int vseg_id;
+    for (vseg_id = 0; vseg_id < header->globals; vseg_id++) 
+    {
+        unsigned int  vpn   = vseg[vseg_id].vbase >> 12;
+        unsigned int  ppn   = 0;  
+        unsigned int  flags = 0;
+        _v2p_translate( ptab , vpn , &ppn , &flags );
+        _printf("@@@ P[%d,%d,0] access vseg %s : vpn = %x / ppn = %x\n",
+                x , y , vseg[vseg_id].name , vpn , ppn );  
+    }
+} 
+
+///////////////////////////////////////////////////////////////////////////////
+// This function is executed by  processor[x][y][0] in each cluster 
+// containing at least one processor.
+// It initialises all page table for all global or private vsegs
+// mapped in cluster[x][y], as specified in the mapping.
 // In each cluster all page tables for the different vspaces must be
 // packed in one vseg occupying one single BPP (Big Physical Page).
 // 
-// This fonction is executed by the processor[x][y][0], the vsegs mapped in the 
-// cluster[x][y] in map.bin file are handled by the processor[x][y][0]
-//
 // For each vseg, the mapping is done in two steps:
 // 1) mapping : the boot_vseg_map() function allocates contiguous BPPs 
 //    or SPPs (if the vseg is not associated to a peripheral), and register
 //    the physical base address in the vseg pbase field. It initialises the
-//    _ptabs_vaddr and _ptabs_paddr arrays if the vseg is a PTAB.
+//    _ptabs_vaddr[] and _ptabs_paddr[] arrays if the vseg is a PTAB.
 //
 // 2) page table initialisation : the boot_vseg_pte() function initialise 
@@ -857,10 +771,11 @@
 //
 // We must handle vsegs in the following order
-//   1) all global vsegs containing a page table,
-//   2) all global vsegs occupying more than one BPP, 
-//   3) all others global vsegs
-//   4) all private vsegs in user space.
+//   1) global vseg containing PTAB mapped in cluster[x][y],
+//   2) global vsegs occupying more than one BPP mapped in cluster[x][y], 
+//   3) others global vsegs mapped in cluster[x][y],
+//   4) all private vsegs in all user spaces mapped in cluster[x][y].
 ///////////////////////////////////////////////////////////////////////////////
-void boot_ptabs_init() 
+void boot_ptab_init( unsigned int cx,
+                     unsigned int cy ) 
 {
     mapping_header_t*   header = (mapping_header_t *)SEG_BOOT_MAPPING_BASE;
